/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : adc_demo.c                                                  *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "adc_demo.h"
#include "dma_demo.h"
uint32_t   g_AdcIntTaken;
int16_t   g_temperature;

void Adc_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;  //adc ͨ
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; //ģ
	GPIO_Init(GPIO_PORT2, &GPIO_InitStructure);//ʼ

	ADC_InitStructure.ADC_Mode = ADC_Mode_Select; //ѡģʽ
	ADC_InitStructure.ADC_ConvSpeed = ADC_ConvSpeed_High; //ٱ任ģʽ
	ADC_InitStructure.ADC_Prescaler = ADC_Prescaler_Div32;//ԤƵ
	ADC_InitStructure.ADC_RefVoltage = ADC_Ref_Vdd; //ʹVDDοѹ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software; //
	ADC_InitStructure.ADC_ContinuousConvMode = ADC_Conv_Continuous;//ת
	ADC_InitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_13p5Cycles; 
	ADC_InitStructure.ADC_UpLimit = ADC_UpLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_InitStructure.ADC_LowLimit = ADC_LowLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_Init(&ADC_InitStructure);

	ISR_Register(ADC_IRQn, adc_interrupt); //жϷ·ע
}

void Adc_HardNoWait_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;  //adc ͨ
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; //ģ
	GPIO_Init(GPIO_PORT2, &GPIO_InitStructure);//ʼ

	ADC_InitStructure.ADC_Mode = ADC_Mode_Select; //ѡģʽ
	ADC_InitStructure.ADC_ConvSpeed = ADC_ConvSpeed_High; //ٱ任ģʽ
	ADC_InitStructure.ADC_Prescaler = ADC_Prescaler_Div32;//ԤƵ
	ADC_InitStructure.ADC_RefVoltage = ADC_Ref_Vdd; //ʹڲοѹ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Hardware_NoWait; //Ӳ
	ADC_InitStructure.ADC_HardwareTrigSour = ADC_HardwareTrig_INTIT;
	ADC_InitStructure.ADC_ContinuousConvMode = ADC_Conv_Oneshot;//ת/ת
	ADC_InitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_13p5Cycles; 
	ADC_InitStructure.ADC_UpLimit = ADC_UpLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_InitStructure.ADC_LowLimit = ADC_LowLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_Init(&ADC_InitStructure);

	ISR_Register(ADC_IRQn, adc_interrupt); //жϷ·ע
}

void Adc_Hardwait_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure = {0};

	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;  //adc ͨ
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; //ģ
	GPIO_Init(GPIO_PORT2, &GPIO_InitStructure);//ʼ

	ADC_InitStructure.ADC_Mode = ADC_Mode_Select; //ѡģʽ
	ADC_InitStructure.ADC_ConvSpeed = ADC_ConvSpeed_High; //ٱ任ģʽ
	ADC_InitStructure.ADC_Prescaler = ADC_Prescaler_Div32;//ԤƵ
	ADC_InitStructure.ADC_RefVoltage = ADC_Ref_Vdd; //ʹڲοѹ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Hardware_Wait; //Ӳ
	ADC_InitStructure.ADC_HardwareTrigSour = ADC_HardwareTrig_INTIT;
	ADC_InitStructure.ADC_ContinuousConvMode = ADC_Conv_Oneshot;//ת
	ADC_InitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_13p5Cycles; 
	ADC_InitStructure.ADC_UpLimit = ADC_UpLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_InitStructure.ADC_LowLimit = ADC_LowLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_Init(&ADC_InitStructure);

	ISR_Register(ADC_IRQn, adc_interrupt); //жϷ·ע
}


void Adc_Scan_Init(void)
{
	GPIO_InitTypeDef      GPIO_InitStructure = {0};
	ADC_InitTypeDef       ADC_InitStructure;

	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; //ģ
	GPIO_Init(GPIO_PORT2, &GPIO_InitStructure);//ʼ

	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_6;
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; //ģ
	GPIO_Init(GPIO_PORT2, &GPIO_InitStructure);//ʼ

	ADC_InitStructure.ADC_Mode = ADC_Mode_Scan; //ɨģʽ
	ADC_InitStructure.ADC_ScanConf.ADC_ChannelSign = ADC_Sign_Enable; //ת4λʾͨ
	ADC_InitStructure.ADC_ConvSpeed = ADC_ConvSpeed_High; //ٱ任ģʽ
	ADC_InitStructure.ADC_Prescaler = ADC_Prescaler_Div32;//ԤƵ
	ADC_InitStructure.ADC_RefVoltage = ADC_Ref_Vdd; //ʹڲοѹ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software; //
	ADC_InitStructure.ADC_ContinuousConvMode = ADC_Conv_Oneshot;//ת
	ADC_InitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_13p5Cycles; 
	ADC_InitStructure.ADC_UpLimit = ADC_UpLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_InitStructure.ADC_LowLimit = ADC_LowLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_Init(&ADC_InitStructure);

	ISR_Register(ADC_IRQn, adc_interrupt); //жϷ·ע
}



/***********************************************************************************************************************
* Function Name: adc_get_temperature
* @brief  ADC Get temperature
* @param  dat - the adc conversion value of ADC_TEMPERSENSOR0 channel
* @return temperature
***********************************************************************************************************************/
#if 0
double adc_get_temperature(int16_t dat)
{
	double temp;    /* temperature value */

	temp = (double)(TSN->TSN25 - dat) * 60 / (TSN->TSN25 - TSN->TSN85) + 25; /* 12bit dat */

	return (temp);
}
#else
int16_t adc_get_temperature(int16_t dat)
{
	int16_t temp;   /* temperature value */

	temp = (int16_t)(TSN->TSN25 - dat) * 60 / (TSN->TSN25 - TSN->TSN85) + 25; /* 12bit dat */

	return (temp);
}
#endif

/***********************************************************************************************************************
* Function Name: adc_interrupt
* @brief  UART1 Receive interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void adc_interrupt(void *msg)
{
	INTC_ClearPendingIRQ(ADC_IRQn);     //clear INTAD interrupt flag
	g_AdcIntTaken++;
#ifdef ADC_BURNTEST
	DMA_Start(DMA_VECTOR_ADC);
#endif
#ifdef ADC_TEMPSENSOR
	g_temperature = adc_get_temperature(ADC->ADCR);	
#endif

}
