/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : adc_demo.c                                                  *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "adc_demo.h"

uint32_t   g_AdcIntTaken;  
int16_t   g_temperature;
uint16_t *gp_u2_adc_buf;
void Adc_Init()
{
	GPIO_InitTypeDef      GPIO_InitStructure ={0};
	ADC_InitTypeDef       ADC_InitStructure ={0};
	ISR_InitTypeDef_t     ISR_InitStructure ={0};
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;  //adc ͨ
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; //ģ
	GPIO_Init(GPIO_PORT2, &GPIO_InitStructure);//ʼ  
	
	ADC_InitStructure.ADC_Mode = ADC_Mode_Select; //ѡģʽ
	ADC_InitStructure.ADC_ConvSpeed = ADC_ConvSpeed_High; //ٱ任ģʽ
	ADC_InitStructure.ADC_Prescaler = ADC_Prescaler_Div32;//ԤƵ
	ADC_InitStructure.ADC_RefVoltage = ADC_Ref_Vdd; //ʹڲοѹ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software; //
	ADC_InitStructure.ADC_ContinuousConvMode = ADC_Conv_Continuous;//ת
	ADC_InitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_13p5Cycles; //ĬϲΪ13.5clk
	ADC_InitStructure.ADC_UpLimit = ADC_UpLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_InitStructure.ADC_LowLimit = ADC_LowLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_Init(&ADC_InitStructure);
	
	ISR_InitStructure.IRQ_Channel = ADC_IRQn;
	ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = adc_interrupt;//жϷ·ע
	ISR_Init(&ISR_InitStructure);
	ADC_Start(ADC_Channel_2);

}

void Adc_Scan_Init()
{
	GPIO_InitTypeDef      GPIO_InitStructure ={0};
	ADC_InitTypeDef       ADC_InitStructure;
	ISR_InitTypeDef_t     ISR_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Ctrl = GPIO_Control_ANA; //ģ
	GPIO_Init(GPIO_PORT2, &GPIO_InitStructure);//ʼ  

	ADC_InitStructure.ADC_Mode = ADC_Mode_Scan; //ɨģʽ
	ADC_InitStructure.ADC_ScanNum = ADC_ScanNum_2;  //2ͨɨ
	ADC_InitStructure.ADC_ConvSpeed = ADC_ConvSpeed_High; //ٱ任ģʽ
	ADC_InitStructure.ADC_Prescaler = ADC_Prescaler_Div32;//ԤƵ
	ADC_InitStructure.ADC_RefVoltage = ADC_Ref_Vdd; //ʹڲοѹ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrig_Software; //
	ADC_InitStructure.ADC_ContinuousConvMode = ADC_Conv_Oneshot;//ת
	ADC_InitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_13p5Cycles; //ĬϲΪ13.5clk
	ADC_InitStructure.ADC_UpLimit = ADC_UpLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_InitStructure.ADC_LowLimit = ADC_LowLimit_Setting; //adc8λ ȽֵĬֵ
	ADC_Init(&ADC_InitStructure);
	
	ISR_InitStructure.IRQ_Channel = ADC_IRQn;
	ISR_InitStructure.IRQ[ISR_InitStructure.IRQ_Channel].intHandle = adc_interrupt;//жϷ·ע
	ISR_Init(&ISR_InitStructure);
}


/**********************************************************************************************************************
Function Name: ADC_Converse_Scan
* @brief  This function starts the AD converter and returns the conversion result in the buf
*         It is suitable for software trigger mode with polling mode.
* @param  ch - specify the ad channel
* @param  scannum - specify scan channels
* @param  times - set the times of ad conversion
* @param  buf - the address where to write the conversion result
* @return average value
***********************************************************************************************************************/
uint16_t Adc_Converse_Scan(ADC_Channel_t ch, ADC_ScanNum_t scannum, uint32_t times, uint16_t *buf)
{
    uint16_t i,j;
    volatile uint8_t  flag;
    uint16_t total = 0;

    INTC_DisableIRQ(ADC_IRQn);     // disable INTAD interrupt 

	ADC->ADM0 &= ~ADC_Enable;

	ADC->ADM1 |= 0x08; //enable one-shot convertion
	ADC->ADM1 |= 0x80; //set sacn mode
	ADC->ADM1 |= (4 - scannum) <<5 ; //set scan channel num

	ADC->ADTRG = ADC_ExternalTrig_Software;
	ADC->ADM0 |= ADC_Enable;
	ADC->ADM2  = 2;    //set convertion result ADCR[15:12] as channel num

	ADC->ADS  = ch;

	for(i=0; i<times;i++)
	{
		ADC->ADM0 |= ADC_Start_Cmp; //adc start
		for (j=0; j<scannum; j++)
		{
			while(INTC_GetPendingIRQ(ADC_IRQn) == 0);
			INTC_ClearPendingIRQ(ADC_IRQn); 	// clear INTAD interrupt flag 

			*buf++ = ADC->ADCR;
			total += ADC->ADCR;
		}
	}
	return (total / times); // return average value
}

/**********************************************************************************************************************
Function Name: Adc_Converse
* @brief  This function starts the AD converter and returns the conversion result in the buf
*         It is suitable for software trigger mode with polling mode.
* @param  ch - specify the ad channel
* @param  times - set the times of ad conversion
* @param  buf - the address where to write the conversion result
* @return average value
***********************************************************************************************************************/
uint16_t Adc_Converse(ADC_Channel_t ch, uint32_t times, uint16_t *buf)
{
    uint16_t i;
    volatile uint8_t  flag;
    uint16_t total = 0;

    INTC_DisableIRQ(ADC_IRQn);     // disable INTAD interrupt 

	ADC->ADM0 &= ~ADC_Enable;

	ADC->ADM1 |= ADC_Conv_Oneshot; //enable one-shot convertion
	ADC->ADTRG = ADC_ExternalTrig_Software;
	ADC->ADM0 |= ADC_Enable;

	ADC->ADS  = ch;

	for(i=0; i<times;i++)
	{
		ADC->ADM0 |= ADC_Start_Cmp;  //adc start
		
		while(INTC_GetPendingIRQ(ADC_IRQn) == 0);
		INTC_ClearPendingIRQ(ADC_IRQn); 	// clear INTAD interrupt flag 

		*buf++ = ADC->ADCR;
		total += ADC->ADCR;
	}
	return (total / times); // return average value
}

/**********************************************************************************************************************
Function Name: ADC_SelfTest
* @brief This function starts the AD converter and returns the conversion result in the buf
*         It is suitable for software trigger mode with polling mode.
* @param  tes - select the self test mode
* @param  times - set the times of ad conversion
* @param  buf - the address where to write the conversion result
* @return average value
***********************************************************************************************************************/
uint16_t ADC_SelfTest(ADC_Test_t tes, uint32_t times, uint16_t *buf)
{
    uint32_t i;
    volatile uint8_t  flag;
    uint32_t total = 0;
	
	INTC_DisableIRQ(ADC_IRQn);     /* disable INTAD interrupt */
	
    if(tes == ADTES_Free_Code)
	{
        ADC->ADM1 = 0x08 | ADC_ConvSpeed_Low;
	}
	else
	{
        ADC->ADM1 = 0x08;
	}
	ADC->ADTRG = ADC_ExternalTrig_Software;
	
	ADC->ADTES = tes;  
    ADC->ADS  = ADC_Channel_OFF; 
	
	for(i=0; i<times;i++)
	{
		if(tes == ADTES_Free_Code)
		{
			 *((uint16_t *)0x40045012) = (((i + 1) * (4096 / times) - 1) << 2);
		}
		ADC->ADM0 |= ADC_Start_Cmp; //adc start

		while(INTC_GetPendingIRQ(ADC_IRQn) == 0);
		INTC_ClearPendingIRQ(ADC_IRQn); 	// clear INTAD interrupt flag 

		*buf++ = ADC->ADCR;
		total += ADC->ADCR;
	}
	return (total / times); // return average value	
}

/***********************************************************************************************************************
* Function Name: ADC_Set_HardTrigger
* @brief  This function sets the trigger of AD converter.
* @param  wait - 0: NoWait; 1: Wait
* @param  trg - select the hard trigger signal
* @return None
***********************************************************************************************************************/
void ADC_Set_HardTrigger(uint8_t wait, ADC_HardwareTrig_t trg)
{
    ADC->ADM0 &= ~ADC_Enable;
    if(wait == 0)
    {
        ADC->ADTRG = ADC_ExternalTrig_Hardware_NoWait | trg;
    }
    else
    {
        ADC->ADTRG = ADC_ExternalTrig_Hardware_Wait   | trg;
    }
    ADC->ADM0 |= ADC_Enable;
}
/***********************************************************************************************************************
* Function Name: adc_get_temperature
* @brief  ADC Get temperature
* @param  dat - the adc conversion value of ADC_TEMPERSENSOR0 channel
* @return temperature
***********************************************************************************************************************/
#if 0
double adc_get_temperature(int16_t dat)
{
    double temp;    /* temperature value */

    temp = (double)(TSN->TSN25 - dat) * 60 / (TSN->TSN25 - TSN->TSN85) + 25; /* 12bit dat */

    return (temp);
}
#else
int16_t adc_get_temperature(int16_t dat)
{
    int16_t temp;   /* temperature value */

    temp = (int16_t)(TSN->TSN25 - dat) * 60 / (TSN->TSN25 - TSN->TSN85) + 25; /* 12bit dat */

    return (temp);
}
#endif


/***********************************************************************************************************************
* Function Name: adc_interrupt
* @brief  UART1 Receive interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void adc_interrupt(void *msg)
{
    INTC_ClearPendingIRQ(ADC_IRQn);     //clear INTAD interrupt flag 
    g_AdcIntTaken++;	
	*gp_u2_adc_buf++ = ADC->ADCR;
	g_temperature = adc_get_temperature(ADC->ADCR);
}
