/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "key_demo.h"
#include "delay_demo.h"
#include "pcbz.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};

    GPIO_PinAFConfig(GPIO_PORT14, GPIO_Pin_0, GPIO_P140, GROUP_AF_CLKBUZ0); // CLKBUZ0 can be alternative to any desired pins with PxxCFG register

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORT14, &GPIO_InitStruct);
	
	PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
	PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
	PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_3;	
	PCBZ_Init(&PCBZ_InitStructure);	
}

int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t i;
    //-----------------------------------------------------------------------
    // Initialize the ports to prevent the leakage current
    //-----------------------------------------------------------------------
	GPIO_Output_Enable(&PORT->P0, 0xFF);
	GPIO_Output_Enable(&PORT->P1, 0xFF);
	GPIO_Output_Enable(&PORT->P2, 0xFF);
	GPIO_Output_Enable(&PORT->P3, 0xFF);
	GPIO_PullUp_Enable(&PORT->P4, 0xFF);
	GPIO_PullUp_Disable(&PORT->P4, 0x01);
	GPIO_Output_Enable(&PORT->P5, 0xFF);
	GPIO_Output_Enable(&PORT->P6, 0xFF); 
	GPIO_Set_Value(&PORT->P6, 0xFF);
	GPIO_Output_Enable(&PORT->P7, 0xFF);	
	GPIO_Output_Enable(&PORT->P12, 0xFF);
	GPIO_PullUp_Enable(&PORT->P13, 0xFF);
	//GPIO_PullUp_Disable(&PORT->P13, 0x80);
	GPIO_Output_Enable(&PORT->P14, 0xFF);	

    //-----------------------------------------------------------------------
    // P140/PCLBUZ0 output
    //-----------------------------------------------------------------------
    PCBZIO_Init();
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------

    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);

    Led_Init();
    Key_Init();
    Key_Start();     // Enable KEY Interrupt

    LED_ON;
    delayMS(500);                            // LED ON: 500ms for reconnect debugger
    LED_OFF;

    //-----------------------------------------------------------------------
    // DeepSleep 10 times
    // P70/KR0 falling edge wakeup system and blinky P71 LED
    //-----------------------------------------------------------------------
    for (i = 10; i > 0;)
    {
        __STOP();       // DeepSleep
        delayMS(20);    // Filter out key jitter

        if (0U == (PORT->P7 & 0x01)) // check key value is 0
        {
            LED_Toggle;
            i--;
        }
    }

    //-----------------------------------------------------------------------
    // DeepSleep 10 times
    // P70/KR0 falling edge wakeup system and blinky P71 LED
    //-----------------------------------------------------------------------
    while (1)
    {
        delayMS(250);
        LED_Toggle;
    }

}




