/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32L051
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "dma_demo.h"
#include "spihs_demo.h"
#include "uart_demo.h"
#include "gpio_demo.h"
#include "delay_demo.h"
#define SPI_WITH_DMA
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint8_t mtx_buf[] = {0xA5, 0x5A, 0xCC, 0x33, 0x3C, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
uint8_t mrx0_buf[13];
extern uint8_t g_spi_tx_end, g_spi_rx_end;



int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t i, err;
    //  uint8_t mtx_buf[] = {0xA5, 0x5A, 0xCC, 0x33, 0x3C, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
    Led_Init();


    Uart0_Init(19200);
    Spihs_Init();  //slave mode

    //  printf("hello\r\n");

#ifdef SPI_WITH_DMA
    Spihs_Dma_Read(mrx0_buf, sizeof(mrx0_buf));

    while (g_spi_rx_end == 0);

#else
    Spihs_Int_Read(mrx0_buf, sizeof(mrx0_buf));

    while (g_spi_rx_end == 0);

#endif
    delayMS(1);

#ifdef SPI_WITH_DMA
    Spihs_Dma_Write(mrx0_buf, sizeof(mrx0_buf));

    while (g_spi_tx_end == 0);

#else
    Spihs_Int_Write(mrx0_buf, sizeof(mrx0_buf));

    while (g_spi_tx_end == 0);

#endif
    err = 0;

    for (i = 0; i < sizeof(mrx0_buf); i++)
    {
        if (mtx_buf[i] != mrx0_buf[i])
        {
            err++;
        }

        printf("0x%x\r\n", mrx0_buf[i]);
    }

    if (err)
    {
        for (i = 0; i < 8; i++)
        {
            LED_Toggle;
            delayMS(250);
        }

        LED_OFF;
    }
    else
    {
        for (i = 0; i < 8; i++)
        {
            LED_Toggle;
            delayMS(250);
        }

        LED_ON;
    }
}



