#ifndef __MOTOR_H__
#define __MOTOR_H__
#include "gpio.h"
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/* value of bemf signal (CW) */
#define     MTR_PATTERN_CW_V_U          (3)             /* V phase to U phase */
#define     MTR_PATTERN_CW_W_U          (1)             /* W phase to U phase */
#define     MTR_PATTERN_CW_W_V          (5)             /* W phase to V phase */
#define     MTR_PATTERN_CW_U_V          (4)             /* U phase to V phase */
#define     MTR_PATTERN_CW_U_W          (6)             /* U phase to W phase */
#define     MTR_PATTERN_CW_V_W          (2)             /* V phase to W phase */

/* value of bemf signal (CCW) */
#define     MTR_PATTERN_CCW_V_U         (2)             /* V phase to U phase */
#define     MTR_PATTERN_CCW_V_W         (6)             /* V phase to W phase */
#define     MTR_PATTERN_CCW_U_W         (4)             /* U phase to W phase */
#define     MTR_PATTERN_CCW_U_V         (5)             /* U phase to V phase */
#define     MTR_PATTERN_CCW_W_V         (1)             /* W phase to V phase */
#define     MTR_PATTERN_CCW_W_U         (3)             /* W phase to U phase */

/* voltage pattern */
#define     MTR_PATTERN_ERROR           (0)             /* bemf pattern error */
#define     MTR_UP_PWM_VN_ON            (1)             /* Up(PWM) to Vn(on) */
#define     MTR_UP_PWM_WN_ON            (2)             /* Up(PWM) to Wn(on) */
#define     MTR_VP_PWM_UN_ON            (3)             /* Vp(PWM) to Un(on) */
#define     MTR_VP_PWM_WN_ON            (4)             /* Vp(PWM) to Wn(on) */
#define     MTR_WP_PWM_UN_ON            (5)             /* Wp(PWM) to Un(on) */
#define     MTR_WP_PWM_VN_ON            (6)             /* Wp(PWM) to Vn(on) */
#define     MTR_UP_ON_VN_PWM            (7)             /* Up(on) to Vn(PWM) */
#define     MTR_UP_ON_WN_PWM            (8)             /* Up(on) to Wn(PWM) */
#define     MTR_VP_ON_UN_PWM            (9)             /* Vp(on) to Un(PWM) */
#define     MTR_VP_ON_WN_PWM            (10)            /* Vp(on) to Wn(PWM) */
#define     MTR_WP_ON_UN_PWM            (11)            /* Wp(on) to Un(PWM) */
#define     MTR_WP_ON_VN_PWM            (12)            /* Wp(on) to Vn(PWM) */
#define     MTR_U_PWM_VN_ON             (13)            /* U(PWM) to Vn(on) */
#define     MTR_U_PWM_WN_ON             (14)            /* U(PWM) to Wn(on) */
#define     MTR_V_PWM_UN_ON             (15)            /* V(PWM) to Un(on) */
#define     MTR_V_PWM_WN_ON             (16)            /* V(PWM) to Wn(on) */
#define     MTR_W_PWM_UN_ON             (17)            /* W(PWM) to Un(on) */
#define     MTR_W_PWM_VN_ON             (18)            /* W(PWM) to Vn(on) */
#define     MTR_UP_ON_V_PWM             (19)            /* Up(on) to V(PWM) */
#define     MTR_UP_ON_W_PWM             (20)            /* Up(on) to W(PWM) */
#define     MTR_VP_ON_U_PWM             (21)            /* Vp(on) to U(PWM) */
#define     MTR_VP_ON_W_PWM             (22)            /* Vp(on) to W(PWM) */
#define     MTR_WP_ON_U_PWM             (23)            /* Wp(on) to U(PWM) */
#define     MTR_WP_ON_V_PWM             (24)            /* Wp(on) to V(PWM) */

/* rotational direction */
#define     MTR_CW                      (0)             /* CW */
#define     MTR_CCW                     (1)             /* CCW */

#define MTR_PORT_UP_SET() do{ \
		GPIO_SetBits(GPIO_PORT1,GPIO_Pin_4);	/* TMIOB0/U+ output H level */ \
}while(0)

#define MTR_PORT_UP_CLR() do{ \
		GPIO_ResetBits(GPIO_PORT1,GPIO_Pin_4);/* TMIOB0/U+ output L level */ \
}while(0)

#define MTR_PORT_VP_SET() do{ \
        GPIO_SetBits(GPIO_PORT1,GPIO_Pin_2);    /* TMIOA1/V+ output H level */ \
}while(0)

#define MTR_PORT_VP_CLR() do{ \
        GPIO_ResetBits(GPIO_PORT1,GPIO_Pin_2);    /* TMIOA1/V+ output L level */ \
}while(0)

#define MTR_PORT_WP_SET() do{ \
         GPIO_SetBits(GPIO_PORT1,GPIO_Pin_0);    /* TMIOB1/W+ output H level */ \
}while(0)

#define MTR_PORT_WP_CLR() do{ \
        GPIO_ResetBits(GPIO_PORT1,GPIO_Pin_0);    /* TMIOB1/W+ output L level */ \
}while(0)

#define MTR_PORT_UN_SET() do{ \
        GPIO_SetBits(GPIO_PORT1,GPIO_Pin_5);    /* TMIOD0/U- output H level */ \
}while(0)

#define MTR_PORT_UN_CLR() do{ \
        GPIO_ResetBits(GPIO_PORT1,GPIO_Pin_5);    /* TMIOD0/U- output L level */ \
}while(0)

#define MTR_PORT_VN_SET() do{ \
        GPIO_SetBits(GPIO_PORT1,GPIO_Pin_3);    /* TMIOC1/V- output H level */ \
}while(0)

#define MTR_PORT_VN_CLR() do{ \
        GPIO_ResetBits(GPIO_PORT1,GPIO_Pin_3);    /* TMIOC1/V- output L level */ \
}while(0)

#define MTR_PORT_WN_SET() do{ \
        GPIO_SetBits(GPIO_PORT1,GPIO_Pin_1);    /* TMIOD1/W- output H level */ \
}while(0)

#define MTR_PORT_WN_CLR() do{ \
        GPIO_ResetBits(GPIO_PORT1,GPIO_Pin_1);    /* TMIOD1/W- output L level */ \
}while(0)
extern volatile uint8_t  g_u1_direction;             /* rotation direction (0:CW ,1:CCW) */
extern volatile uint8_t  g_u1_v_pattern_open[2][7];
void mtr_pattern_set(uint8_t u1_pattern);

#endif
