/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"
#include "dma_demo.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/


int main()
{
    uint32_t msCnt, len, i; // count value of 1ms
    uint8_t rxbuf[64];

    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock); //ʱʼ

    Uart0_Init(19200);

#ifdef UART0_DMA_RCV
    /*0ͨDMAղ*/
    DMA_Uart0_Rx(DMA_VECTOR_SR0, DMA_Mode_Repeat, (void *)&UART0_RX, UART0_RX_BUF, UART_MAX_RECV_LEN); //config dma transmission

#endif
    Uart1_Init(38400);

    Uart2_Init(9600);
#ifdef  BAT32G1XX_80PIN	
    Uart3_Init(9600);
#endif
    while (1)
    {
        delayMS(1000);

#ifdef UART0_DMA_RCV
        len = Uart0_Dma_Rcv(rxbuf);

        if (len)
        {
            Uart0_Dma_Send(rxbuf, len);
        }

#else
        if (UART0_RX_STA & 0x8000U)
        {
            //          Uart0_IntSend(UART0_RX_BUF,UART0_RX_STA&0x3fff); //жϷ
            //          Uart0_Dma_Send(UART0_RX_BUF,UART0_RX_STA&0x3fff);//DMA 
            for (i = 0; i < (UART0_RX_STA & 0x3fff); i++)   //ѯ
            {
                Uart0_Send(UART0_RX_BUF[i]);
            }

            UART0_RX_STA = 0;
        }
#endif
        if (UART1_RX_STA & 0x8000U)     //
        {
            Uart1_IntSend(UART1_RX_BUF, UART1_RX_STA & 0x3fff);
            UART1_RX_STA = 0;
        }

        if (UART2_RX_STA & 0x8000U)
        {
            Uart2_IntSend(UART2_RX_BUF, UART2_RX_STA & 0x3fff);
            UART2_RX_STA = 0;
        }
#ifdef  BAT32G1XX_80PIN	
        if (UART3_RX_STA & 0x8000U)
        {
            Uart3_IntSend(UART3_RX_BUF, UART3_RX_STA & 0x3fff);
            UART3_RX_STA = 0;
        }
#endif
    }
}




